/*
* Template-File src/main/takatuka/templates/EntityAbstractSearch.vm
*/
package de.ivu.elect.business.benutzerverwaltung.boundary;

import java.util.List;

import javax.inject.Inject;

import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerParameter;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.jee.presentation.search.WildcardConverter;

public abstract class AbstractBenutzerParameterSearch {

  @Inject
  protected transient BenutzerParameterExtendedDAO dao;

  public AbstractBenutzerParameterSearch() {
    super();
  }

  public List<BenutzerParameter> getSearchResult(BenutzerParameterSearchParameters searchParameters, EagerLoadingCollector<BenutzerParameter> eagerLoadingCollector) {
    return eagerLoadingCollector.eagerLoad(querySearchResult(searchParameters));
  }

  protected abstract List<BenutzerParameter> querySearchResult(BenutzerParameterSearchParameters searchParameters);

  protected String convertSearchPattern(String patternInput) {
    return new WildcardConverter().addAndConvertToJpqlLikeExpression(patternInput);
  }
}
